using System;
using System.Reflection;
using System.Runtime.InteropServices;

namespace CDieseListeurProfs
{
   [InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
   [GuidAttribute("CEE546C9-0FC2-4b74-BE47-4E888D8FC5CE")]
   public interface IListeurProfs
   {
      int GetNbProfs ();
      void GetProfs (int Capacite, out string [] Noms, out int NbObtenus);
   }
   [GuidAttribute("8B1C7446-7FF2-4413-93B9-B7F68C2CDEA7")]
	public class Listeur : IListeurProfs
	{
      private int m_NbProfs;
      private string [] m_Noms;
      public Listeur ()
      {
         m_NbProfs = 3;
         m_Noms = new string [GetNbProfs ()];
         m_Noms[0] = "Fwank";
         m_Noms[1] = "Saliha";
         m_Noms[2] = "Ben";
      }
      public int GetNbProfs ()
      {
         return m_NbProfs;
      }
      public void GetProfs (int Capacite, out string [] Noms, out int NbObtenus)
      {
         int NbCopier = System.Math.Min (Capacite, GetNbProfs ());
         string [] temp = new string [NbCopier];
         for (int i = 0; i < NbCopier; i++) temp[i] = m_Noms[i];
         NbObtenus = NbCopier;
         Noms = temp;
      }
   }
}
